unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, Spin, StdCtrls, ColorBox, SliderBars;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    ColorBox1: TColorBox;
    ColorBox2: TColorBox;
    ColorBox3: TColorBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure CheckBox2Change(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure ColorBox2Change(Sender: TObject);
    procedure ColorBox3Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    SliderBar: TColorBar;
    procedure SliderBarChange(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LCLIntf;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  SliderBar := TColorBar.create(self);
  with SliderBar do begin
    left := 20;
    top := 20;
    parent := self;
    Setcolors(RGB(0,0,0), RGB(255,0,0));
    Associate := SpinEdit1;
    MinValue := 0;
    MaxValue := 255;
    OnChange := @SliderBarChange;
  end;
end;

procedure TForm1.SliderBarChange(Sender: TObject);
begin
  Label6.Caption := Format('%.2f', [SliderBar.Position]);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  SliderBar.MarkerStyle:= TMarkerStyle(ComboBox1.ItemIndex);
end;

procedure TForm1.ColorBox1Change(Sender: TObject);
begin
  SliderBar.MarginColor := ColorBox1.Selected;
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
var
  wd, ht: integer;
begin
  with SliderBar do begin
    wd := width;
    ht := height;
    SetBounds(left, top, ht, wd);
    if CheckBox1.Checked then
      Orientation := sboVertical
    else
      Orientation := sboHorizontal;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  close
end;

procedure TForm1.CheckBox2Change(Sender: TObject);
begin
  if CheckBox2.Checked then
    SliderBar.MaxValue := 100
  else
    SliderBar.MaxValue := 255;
end;

procedure TForm1.ColorBox2Change(Sender: TObject);
begin
  SliderBar.BorderColor := ColorBox2.Selected;
end;

procedure TForm1.ColorBox3Change(Sender: TObject);
begin
  SliderBar.MarkerColor := ColorBox3.Selected;
end;

end.

