unit pickerdlg;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls,
  Graphics, Dialogs, StdCtrls, Spin, ExtCtrls, ButtonPanel,
  SliderBars;

type

  { Tpickerform }

  TPickerForm = class(TForm)
    ButtonPanel1: TButtonPanel;
    Label5: TLabel;
    RedBar: TColorBar;
    GreenBar: TColorBar;
    BlueBar: TColorBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    colorBar: TSliderBar;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    procedure ColorBarChange(Sender: TObject);
    procedure colorBarPaint(Sender: TObject; aRect: TRect);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
    FInitial, FSelected: packed record
      case boolean of
        false: (color: TColor);
        true: (Red: byte;
               Green: byte;
               Blue: byte;
               Alpha: byte);
      end;
    procedure RedrawBars;
  public
    { public declarations }
    property InitialColor: TColor read FInitial.Color write FInitial.Color;
    property SelectedColor: TColor read FSelected.color;
  end;

implementation

{$R *.lfm}

uses
  LCLIntf;

{ TPickerForm }

procedure TPickerForm.ColorBarChange(Sender: TObject);
begin
  // when one colour chanel value is changed
  // all the colours bars need to be redrawn
  RedrawBars;
end;

(*
procedure TPickerForm.colorBarPaint(Sender: TObject; aRect: TRect);
var
  bRect: TRect;
begin
  // let bRect equal to the left half of aRect
  bRect := aRect;
  bRect.Right := bRect.Right div 2;
  // and shrink aRect to its right half
  aRect.Left := bRect.Right;

  with Sender as TSliderBar do begin
    with canvas do begin
      // fill the left half with the initial colour
      brush.color := InitialColor;
      FillRect(bRect);
      // and fill the right half with the currently selected colour
      brush.color := SelectedColor;
      FillRect(aRect);
    end;
  end;
end;
*)

procedure TPickerForm.colorBarPaint(Sender: TObject; aRect: TRect);
var
  middle: integer;
  orgRight: integer;
begin
  orgRight := aRect.Right;
  middle := (aRect.left + orgRight) div 2;
  with Sender as TSliderBar do begin
    with canvas do begin
      // fill the left half with the initial colour
      aRect.right := middle;
      brush.color := InitialColor;
      FillRect(aRect);
      // and fill the right half with the currently selected colour
      aRect.Right := orgRight;
      aRect.Left := middle;
      brush.color := SelectedColor;
      FillRect(aRect);
    end;
  end;
end;

procedure TPickerForm.FormShow(Sender: TObject);
begin
  RedBar.value := FInitial.Red;
  GreenBar.value := FInitial.Green;
  BlueBar.value := FInitial.Blue;
end;

procedure TPickerForm.RedrawBars;
begin
  with FSelected do begin
    // update the selected colour using the colour bar values
    // one of which has presumably been changed
    Red := RedBar.value;
    Green := GreenBar.value;
    Blue := BlueBar.value;
    // redraw all the colour bars, because they are interdependant
    RedBar.SetColors(RGB(0, Green, Blue), RGB(255, Green, Blue));
    GreenBar.SetColors(RGB(Red, 0, Blue), RGB(Red, 255, Blue));
    BlueBar.SetColors(RGB(Red, Green, 0), RGB(Red, Green, 255));
    // update the hexadecima value of the selected color
    label4.Caption := Format('%.2x%.2x%.2x', [Red, Green, Blue]);
  end;
  // redraw the control showing the selected color
  colorBar.Invalidate;
end;

end.

